//To do: fix window-size after back has been shown


var timer
var color = "#ffffff"
var background = "black"
var backgrounds = new Array("black","orchid","ice","lime", "tiger", "mandarin", "salmon", "clear")
var backgroundsIndex = 0
var noShadow = 0

var e=new Array("","X","XX", "XXX", "XL", "L")
var f=new Array("", "I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX")


function debug(tag)
{
	document.getElementById('debug').style.display="block"
	document.getElementById('debug').value=tag
}

function setup()
{
	//Retieve prefs etc.
	
	if(window.widget)
	{
		color = widget.preferenceForKey("color");
		if (!color)
			color="#cccccc"
		
		backgroundsIndex = widget.preferenceForKey("backgroundsIndex");
		if (!backgroundsIndex)
			backgroundsIndex = 0
			
		noShadow = widget.preferenceForKey("noShadow");
		if (!noShadow)
			noShadow = 0
		
	}
	originalColour = color
	
	
	document.getElementById('time').style.color= color
	document.getElementById('frontImage').src= "images/" + backgrounds[backgroundsIndex] + ".png"
	
	
	
	
	if(noShadow)
		document.getElementById('time').style.textShadow="#000 0 0 0"
		
	if(timer == null)
		timer = setInterval("updateTime();", 1000);
}

function updateTime()
{
	da= new Date();
	document.getElementById('time').innerHTML=rom(da.getHours())  +":"+  rom(da.getMinutes()) +":"+ rom(da.getSeconds());
}

function rom(t)
{
	b=t%10
	a=(t-b)/10
	return e[a]+f[b];
}






////////////////////////////////////////////////////
////	Preferences & Backside interaction
////////////////////////////////////////////////////


function changeSettings()
{
	if(document.getElementById('field').style.BackgroundColor !="")
	{
			
		document.getElementById('time').style.color= originalColour
		
		if (window.widget)
			widget.setPreferenceForKey(originalColour,"color");
	}
	
	
	temp=document.getElementById('shadow').checked
	
	if(temp)
		noShadow=0
	else
		noShadow=1
	
	if(noShadow)
		document.getElementById('time').style.textShadow="#000 0 0 0"
	else
		document.getElementById('time').style.textShadow="#000 0.0em 0.0em 0.1em"
	
	
	 if(window.widget)
		widget.setPreferenceForKey(noShadow,"noShadow");
}

function changeBackground()
{
	backgroundsIndex++;
	if(backgroundsIndex>(backgrounds.length-1))
		backgroundsIndex=0;
	
	if (window.widget)
		widget.setPreferenceForKey(backgroundsIndex,"backgroundsIndex");
	
	updateHole()
	document.getElementById('frontImage').src= "images/" + backgrounds[backgroundsIndex] + ".png"
	
}

function updateHole()
{	
	document.getElementById('hole').style.background="url(\'images/"+backgrounds[backgroundsIndex] +".png\')"
	
	tempString=backgrounds[backgroundsIndex]
	document.getElementById('hole').title= "Click to change\nCurrent: \"" + (tempString.substr(0,1)).toUpperCase() + tempString.substr(1)+ "\""
}


function toggleShadow()
{
	if(document.getElementById('shadow').checked)
		document.getElementById('shadow').checked=0
	else
		document.getElementById('shadow').checked=1
}



////////////////////////////////////////////////////
////	Show/hide events	
////////////////////////////////////////////////////


function onshow () {
	if (timer == null) {
		timer = setInterval("updateTime();", 1000);
	}
}

function onhide () {
	if (timer != null) {
		clearInterval(timer);
		timer = null;
	}
}





////////////////////////////////////////////////////
////	Flipping sides
////////////////////////////////////////////////////

function showBack()
{
	document.getElementById("doneButton").src = "images/done.png";
	document.getElementById('field').style.BackgroundColor= originalColour;
	if(!noShadow)
		temp=document.getElementById('shadow').value="1"
		
	updateHole()
	
	if (window.widget)
		window.resizeTo(288, 150);
	
	
	
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget)
	{
		widget.prepareForTransition("ToBack");
	}
	front.style.display="none";
	back.style.display="block";
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}





function hideBack()
{

		
	changeSettings()
	
	//////////////////////////////
	//  generic stuff
	
	document.getElementById('fliprollie').style.display = 'none';
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	back.style.display="none";
	front.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	
	setTimeout ('if(window.widget){window.resizeTo(288, 100);};', 1);
}










function openU(link)
{
	if(window.widget)
		widget.openURL(link);	
	else
		window.open(link)
}



////////////////////////////////////////////////////
////	ColourPicker
////////////////////////////////////////////////////





var closeTag, rC, originalColour;

document.addEventListener("keydown", keyPressed, true);


function keyPressed(event)
{
	if(parseInt(event.keyCode)==27)
		cancelCP()
}


function toggleCP()
{
	if(document.getElementById('fields').style.display=="block")
		closeCP()
	else
		showCP()	
}

function showCP(){
	document.getElementById('fields').style.display="block"
	document.getElementById('container').style.width=""
	document.getElementById('field').style.borderStyle ="inset"
	
}

function closeCP()
{
	document.getElementById('fields').style.display="none"
	document.getElementById('container').style.width="20"
	document.getElementById('field').style.borderStyle ="outset"
	originalColour = document.getElementById('field').style.backgroundColor
}
		

function cancelCP()
{
	closeCP()
	resetColour()
}
		 
			
function closeSoon()
{
	closeTag = window.setTimeout("closeCP();", 320);
	rC = window.setTimeout("resetColour();", 10);
}

		
function cancelClose()
{
	window.clearTimeout(closeTag)
	window.clearTimeout(rC)
}


function hc(e)	//hoverColour
{
	temp=String(e.target.parentNode.style.backgroundColor)
	if(temp.indexOf("rgb")>-1)
		document.getElementById('field').style.backgroundColor = temp
}
		

function resetColour()
{
	document.getElementById('field').style.backgroundColor= originalColour
}















////////////////////////////////////////////////////
////	Don't mess with
////////////////////////////////////////////////////



var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}
function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}